package se.paxport.yggejonssoncrazysnake;

import se.citerus.crazysnake.Position;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Map;

public class FruitDistanceSorter {

    private static final FruitSorter FRUIT_SORTER = new FruitSorter();

    private final List<FruitDistance> fruitDistances = new ArrayList<FruitDistance>();

    public void add(FruitDistance fruitDistance) {
        fruitDistances.add(fruitDistance);
    }

    public List<Position> getDistances() {
        Collections.sort(fruitDistances, FRUIT_SORTER);
        List<Position> positions = new ArrayList<Position>();
        for (FruitDistance fruitDistance : fruitDistances) {
            positions.add(fruitDistance.getFruitPosition());
        }
        return positions;
    }

    public void addCloseFruits(Map<Position, Map<Position, Integer>> fruitToFruitDistance) {
        for (FruitDistance fruitDistance : fruitDistances) {
            fruitDistance.addCloseFruits(fruitToFruitDistance);
        }
    }

    private static class FruitSorter implements Comparator<FruitDistance> {

        @Override
        public int compare(FruitDistance dist1, FruitDistance dist2) {
            if (dist1.getMyDist() < dist1.getOppDist() && dist2.getMyDist() < dist2.getOppDist()) {
                return dist1.compareFruitDistances(dist2);
            } else if (dist1.getMyDist() == dist1.getOppDist()) {
                if (dist2.getMyDist() == dist2.getOppDist()) {
                    return dist2.getOppDist() - dist1.getOppDist();
                }
                return 1;
            } else {
                return -1;
            }
        }
    }
}
