package se.paxport.yggejonssoncrazysnake;

public class Pair<T extends Comparable<T>, U> implements Comparable<Pair<T, U>> {

    private final T first;
    private final U second;

    public Pair(T first, U second) {
        this.first = first;
        this.second = second;
    }

    public T getFirst() {
        return first;
    }

    public U getSecond() {
        return second;
    }

    @Override
    public int compareTo(Pair<T, U> o) {
        return first.compareTo(o.first);
    }
}
